<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="用户昵称" prop="nickName">
        <el-input
          v-model="queryParams.nickName"
          placeholder="请输入用户昵称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="客服角色" prop="roleId">
        <el-select v-model="queryParams.roleId" placeholder="请选择客服角色" clearable size="small">
          <el-option
                v-for="item in roles"
                :key="item.roleId"
                :label="item.roleName"
                :value="item.roleId"
              />
        </el-select>
      </el-form-item>
      <el-form-item label="消息类型" prop="msgType">
          <el-select v-model="queryParams.msgType" placeholder="请选择类型" clearable size="small">
           <el-option
             v-for="item in typeOptions"
               :key="item.dictValue"
               :label="item.dictLabel"
               :value="item.dictValue"
             />
          </el-select>
      </el-form-item>

      <el-form-item label="发送时间" prop="createTime">
        <el-date-picker
           style="width:220px"
           clearable size="small"
           v-model="dateRange"
           type="daterange"
           value-format="yyyy-MM-dd"
           start-placeholder="开始日期"
           end-placeholder="结束日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['chat:chatMsg:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="chatMsgList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="msgId" />
      <el-table-column label="用户" align="center" prop="nickName" />
      <el-table-column label="头像" width="150" align="center">
        <template slot-scope="scope">
          <img :src="scope.row.avatar" style="height: 80px">
        </template>
      </el-table-column>
      <el-table-column label="AI客服" align="center" prop="roleName" />
      <el-table-column show-overflow-tooltip label="消息内容" align="center" prop="content" />
      <el-table-column  label="消息类型"  align="center" prop="msgType">
            <template slot-scope="scope">
                <el-tag prop="type" v-for="(item, index) in typeOptions"    v-if="scope.row.msgType==item.dictValue">{{item.dictLabel}}</el-tag>
              </template>
      </el-table-column>
      <el-table-column  label="发送方式"  align="center" prop="sendType">
            <template slot-scope="scope">
                <el-tag prop="type" v-for="(item, index) in sendTypeOptions"    v-if="scope.row.sendType==item.dictValue">{{item.dictLabel}}</el-tag>
            </template>
      </el-table-column>

      <el-table-column label="发送时间" align="center" prop="createTime" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listFastGptChatMsg, getFastGptChatMsg, delFastGptChatMsg, addFastGptChatMsg, updateFastGptChatMsg, exportFastGptChatMsg } from "@/api/fastGpt/fastGptChatMsg";
import { getAllRoleList } from "@/api/fastGpt/fastGptRole";

export default {
  name: "ChatMsg",
  data() {
    return {
      show:{
              title:"聊天详情",
              open:false,
            },
      roles:[],
      dateRange:[],
      typeOptions:[],
      sendTypeOptions:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 聊天消息记录表格数据
      chatMsgList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        chatId: null,
        content: null,
        msgType: null,
        sendType: null,
        companyId: null,
        roleId: null,
        companyUserId: null,
        msgJson: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getDicts("chat_msg_type").then((response) => {
      this.typeOptions = response.data;
    });
    this.getDicts("chat_msg_send_type").then((response) => {
      this.sendTypeOptions = response.data;
    });
    getAllRoleList().then(response => {
        this.roles = response.data;
    });
    this.getList();
  },
  methods: {
    handleShow(){

    },
    /** 查询聊天消息记录列表 */
    getList() {
      this.loading = true;
      listFastGptChatMsg(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.chatMsgList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        msgId: null,
        chatId: null,
        content: null,
        msgType: null,
        sendType: null,
        companyId: null,
        roleId: null,
        companyUserId: null,
        createTime: null,
        msgJson: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.dateRange=null
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.msgId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加聊天消息记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const msgId = row.msgId || this.ids
      getFastGptChatMsg(msgId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改聊天消息记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.msgId != null) {
            updateFastGptChatMsg(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFastGptChatMsg(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const msgIds = row.msgId || this.ids;
      this.$confirm('是否确认删除聊天消息记录编号为"' + msgIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delFastGptChatMsg(msgIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有聊天消息记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportFastGptChatMsg(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>

<style lang="css">
  .el-tooltip__popper{
    max-width:40%
  }
</style>
